package be.iminds.ilabt.jfed.experimenter_gui.dialogs;

import be.iminds.ilabt.jfed.experimenter_gui.ui.AbstractDialogFactory;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Testbed;
import javafx.fxml.FXMLLoader;
import javafx.stage.Stage;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;
import javax.inject.Provider;
import javax.inject.Singleton;
import java.net.URL;

@Singleton
public class JFedBrowserFactory {
    private final AbstractDialogFactory dialogFactory;

    @Inject
    public JFedBrowserFactory(Provider<FXMLLoader> loaderProvider,
                              @Named("parentStage") Provider<Stage> parentStageProvider) {
        this.dialogFactory = new AbstractDialogFactory(loaderProvider, parentStageProvider) {
            @Override
            protected String getTitle() {
                return "jFed Browser";
            }

            @Override
            protected URL getFxmlLocation() {
                return JFedBrowserFactory.class.getResource("JFedBrowser.fxml");
            }
        };
    }

    public void showDialog() {
        showDialog(null);
    }
    public void showDialog(@Nullable String initialUrl) {
        AbstractDialogFactory.StageAndController stageAndController = this.dialogFactory.createStage();
        JFedBrowser controller = (JFedBrowser)stageAndController.getController();
        controller.setInitialUrl(initialUrl);

        stageAndController.getStage().showAndWait();
    }
}
